"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _plugins = require("./plugins");

var _stats = _interopRequireDefault(require("./stats"));

/**************************************************
 * Created by nanyuantingfeng on 23/08/2017 17:19.
 **************************************************/
var DEFAULT_PORT = 8080;
var DEFAULT_HOST = '127.0.0.1';

function parseProxyWithOptions(proxy, options) {
  var oo = {};
  var keys = Object.keys(proxy);
  keys.forEach(function (key) {
    var target = proxy[key];
    oo[key] = typeof target === 'string' ? (0, _objectSpread2.default)({
      target: target
    }, options) : (0, _objectSpread2.default)({}, target, options);
  });
  return oo;
}

function _default(_x, _x2) {
  return _ref.apply(this, arguments);
}

function _ref() {
  _ref = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(context, next) {
    var devServer, proxy, proxyOptions, plugins, DIRs, proxyObj;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            context.devServer = {};
            context.proxy = {};
            context.proxyOptions = {
              changeOrigin: true
            };
            context.isDevServer = true;
            next();
            devServer = context.devServer, proxy = context.proxy, proxyOptions = context.proxyOptions, plugins = context.plugins, DIRs = context.DIRs;
            proxyObj = parseProxyWithOptions(proxy, proxyOptions);
            context.webpackConfig.devServer = context.devServer = (0, _objectSpread2.default)({
              port: context.port || DEFAULT_PORT,
              host: DEFAULT_HOST,
              hot: true,
              hotOnly: true,
              contentBase: DIRs.root,
              compress: true,
              disableHostCheck: true,
              overlay: true,
              headers: {
                'Access-Control-Allow-Origin': '*'
              },
              historyApiFallback: true,
              proxy: proxyObj,
              stats: _stats.default
            }, devServer);
            plugins.push(new _plugins.HotModuleReplacementPlugin());

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _ref.apply(this, arguments);
}